apiVersion: {{ deployment_apivers }}
kind: {{ deployment_kind }}
metadata:
  labels:
{% if pki_set | length > 0 %}
    pki.opsperator.io/has-ca: {{ pki_set | join(',') }}
{% endif %}
    {{ network_policy_deployment_label }}: {{ awx_name }}
  name: {{ awx_name }}
  namespace: {{ namespace }}
spec:
  replicas: {{ awx_replicas }}
  revisionHistoryLimit: {{ deploy_revision_history_limit | default(10) }}
  selector:
{% if deployment_kind != 'DeploymentConfig' %}
    matchLabels:
      name: {{ awx_name }}
  strategy:
    type: RollingUpdate
{% else %}
    name: {{ awx_name }}
  strategy:
    resources:
      limits:
        cpu: {{ deploy_pod_cpu_limit }}
        memory: {{ deploy_pod_memory_limit }}
      requests:
        cpu: {{ deploy_pod_cpu_request }}
        memory: {{ deploy_pod_memory_request }}
    type: Rolling
{% endif %}
  template:
    metadata:
      labels:
        name: {{ awx_name }}
{% if pki_set | length > 0 %}
        pki.opsperator.io/has-ca: {{ pki_set | join(',') }}
{% endif %}
    spec:
{% if do_affinities %}
      affinity:
        podAntiAffinity:
{% if scheduling_affinity_required %}
          requiredDuringSchedulingIgnoredDuringExecution:
          - labelSelector:
              matchExpressions:
              - key: name
                operator: In
                values: [ {{ awx_name }} ]
            topologyKey: {{ k8s_affinity_zone_label }}
{% else %}
          preferredDuringSchedulingIgnoredDuringExecution:
          - podAffinityTerm:
              labelSelector:
                matchExpressions:
                - key: name
                  operator: In
                  values: [ {{ awx_name }} ]
              topologyKey: {{ k8s_affinity_zone_label }}
            weight: 42
{% endif %}
{% endif %}
      automountServiceAccountToken: false
      containers:
      - env:
        - name: DEBUG
          value: "{% if do_debugs %}yay{% endif %}"
        - name: TZ
          value: {{ timezone }}
{% if do_triggers == False or (opsimages | json_query("[?name=='awx'].short"))[0] == False %}
        image: {{ (opsimages | json_query("[?name=='awx'].image"))[0] }}
{% endif %}
        imagePullPolicy: {{ pull_policy }}
{% if awx_was_init %}
        livenessProbe:
{% if k8s_flavor == 'openshift' and ocp_major in [ 3, '3' ] %}
          failureThreshold: 28
{% else %}
          failureThreshold: 5
{% endif %}
          initialDelaySeconds: 30
          periodSeconds: 20
          tcpSocket:
            port: 8052
          timeoutSeconds: 3
{% endif %}
        name: web
        ports:
        - containerPort: 8052
{% if awx_was_init %}
        readinessProbe:
          httpGet:
            path: /
            port: 8052
          initialDelaySeconds: 30
          periodSeconds: 15
          timeoutSeconds: 3
{% endif %}
        resources:
          limits:
            cpu: "{{ awx_web_cpu_limit }}"
            memory: "{{ awx_web_memory_limit }}"
          requests:
            cpu: "{{ awx_web_cpu_request }}"
            memory: "{{ awx_web_memory_request }}"
{% if not (k8s_flavor == 'openshift' and ocp_major in [ 3, '3' ]) %}
        startupProbe:
          failureThreshold: 28
          initialDelaySeconds: 30
          periodSeconds: 20
          tcpSocket:
            port: 8052
{% endif %}
        volumeMounts:
{% if smtps_address | default(False) and k8s_flavor == 'kubernetes' %}
        - mountPath: /certs
          name: pkiconf
{% endif %}
        - mountPath: /etc/nginx/nginx.conf
          name: awx-nginx-config
          readOnly: true
          subPath: nginx.conf
        - mountPath: /etc/tower/SECRET_KEY
          name: awx-secret-key
          readOnly: true
          subPath: SECRET_KEY
        - mountPath: /etc/tower/conf.d/
          name: awx-application-credentials
          readOnly: true
        - mountPath: /etc/tower/settings.py
          name: awx-application-config
          readOnly: true
          subPath: settings.py
        - mountPath: /supervisor.conf
          name: awx-supervisor-web-config
          readOnly: true
          subPath: supervisor.conf
        - mountPath: /supervisor_task.conf
          name: awx-supervisor-task-config
          readOnly: true
          subPath: supervisor_task.conf
        - mountPath: /usr/bin/launch_awx.sh
          name: awx-launch-awx-web
          readOnly: true
          subPath: launch_awx.sh
        - mountPath: /usr/bin/launch_awx_task.sh
          name: awx-launch-awx-task
          readOnly: true
          subPath: launch_awx_task.sh
        - mountPath: /var/lib/awx/rsyslog
          name: rsyslog-dir
        - mountPath: /var/run/awx-rsyslog
          name: rsyslog-socket
        - mountPath: /var/run/redis
          name: awx-redis-socket
        - mountPath: /var/run/supervisor
          name: supervisor-socket
      - command:
        - /usr/bin/launch_awx_task.sh
        env:
        - name: SUPERVISOR_WEB_CONFIG_PATH
          value: /supervisor.conf
        - name: AWX_SKIP_MIGRATIONS
          value: "1"
        - name: MY_POD_UID
          valueFrom:
            fieldRef:
              fieldPath: metadata.uid
        - name: MY_POD_IP
          valueFrom:
            fieldRef:
              fieldPath: status.podIP
{% if do_triggers == False or (opsimages | json_query("[?name=='awx'].short"))[0] == False %}
        image: {{ (opsimages | json_query("[?name=='awx'].image"))[0] }}
{% endif %}
        imagePullPolicy: {{ pull_policy }}
        name: tasks
        resources:
          limits:
            cpu: "{{ awx_tasks_cpu_limit }}"
            memory: "{{ awx_tasks_memory_limit }}"
          requests:
            cpu: "{{ awx_tasks_cpu_request }}"
            memory: "{{ awx_tasks_memory_request }}"
        securityContext:
          privileged: true
        volumeMounts:
{% if smtps_address | default(False) and k8s_flavor == 'kubernetes' %}
        - mountPath: /certs
          name: pkiconf
{% endif %}
        - mountPath: /etc/tower/SECRET_KEY
          name: awx-secret-key
          readOnly: true
          subPath: SECRET_KEY
        - mountPath: /etc/tower/conf.d/
          name: awx-application-credentials
          readOnly: true
        - mountPath: /etc/tower/settings.py
          name: awx-application-config
          readOnly: true
          subPath: settings.py
        - mountPath: /supervisor.conf
          name: awx-supervisor-web-config
          readOnly: true
          subPath: supervisor.conf
        - mountPath: /supervisor_task.conf
          name: awx-supervisor-task-config
          readOnly: true
          subPath: supervisor_task.conf
        - mountPath: /usr/bin/launch_awx.sh
          name: awx-launch-awx-web
          readOnly: true
          subPath: launch_awx.sh
        - mountPath: /usr/bin/launch_awx_task.sh
          name: awx-launch-awx-task
          readOnly: true
          subPath: launch_awx_task.sh
        - mountPath: /var/lib/awx/rsyslog
          name: rsyslog-dir
        - mountPath: /var/run/awx-rsyslog
          name: rsyslog-socket
        - mountPath: /var/run/redis
          name: awx-redis-socket
        - mountPath: /var/run/supervisor
          name: supervisor-socket
      - args:
        - redis-server
        - /etc/redis/redis.conf
{% if do_triggers == False or (opsimages | json_query("[?name=='redis'].short"))[0] == False %}
        image: {{ (opsimages | json_query("[?name=='redis'].image"))[0] }}
{% endif %}
        imagePullPolicy: {{ pull_policy }}
        name: redis
        resources:
          limits:
            cpu: "{{ redis_cpu_limit }}"
            memory: "{{ redis_memory_limit }}"
          requests:
            cpu: "{{ redis_cpu_limit }}"
            memory: "{{ redis_memory_limit }}"
        securityContext:
          allowPrivilegeEscalation: false
        volumeMounts:
        - mountPath: /etc/redis/redis.conf
          name: awx-redis-config
          readOnly: true
          subPath: redis.conf
        - mountPath: /var/run/redis
          name: awx-redis-socket
{% if k8s_resource_nodes_selectors | length > 0 %}
      nodeSelector:
{% for sel in k8s_resource_nodes_selectors %}
        {{ sel.split('=')[0] }}: "{{ sel.split('=')[1] if (sel.split('=') | length > 1) else '' }}"
{% endfor %}
{% endif %}
{% if k8s_flavor == 'kubernetes' or (k8s_flavor == 'openshift' and ocp_major in [ 4, '4' ]) %}
      priorityClassName: opsperator-application
{% endif %}
      securityContext:
        fsGroup: 0
{% if (k8s_flavor == 'kubernetes' and do_podsecuritypolicy) or k8s_flavor == 'openshift' %}
      serviceAccountName: {{ awx_name }}
{% else %}
      serviceAccountName: default
{% endif %}
{% if do_topology_spread_constraints | default(False) %}
      topologySpreadConstraints:
      - labelSelector:
          matchLabels:
            name: {{ awx_name }}
        maxSkew: {{ topology_spread_max_skew | default(1) }}
        topologyKey: {{ k8s_affinity_zone_label }}
{% if scheduling_affinity_required %}
        whenUnsatisfiable: DoNotSchedule
{% else %}
        whenUnsatisfiable: ScheduleAnyway
{% endif %}
{% endif %}
      volumes:
      - emptyDir: {}
        name: rsyslog-dir
      - emptyDir: {}
        name: rsyslog-socket
      - emptyDir: {}
        name: supervisor-socket
      - configMap:
          items:
          - key: settings
            path: settings.py
          name: {{ awx_name }}
        name: awx-application-config
      - name: awx-application-credentials
        secret:
          items:
          - key: credentials_py
            path: credentials.py
          - key: environment_sh
            path: environment.sh
          secretName: {{ awx_name }}
      - configMap:
          defaultMode: 0755
          items:
          - key: launch-awx-task
            path: launch_awx_task.sh
          name: {{ awx_name }}-scripts
        name: awx-launch-awx-task
      - configMap:
          defaultMode: 0755
          items:
          - key: launch-awx-web
            path: launch_awx.sh
          name: {{ awx_name }}-scripts
        name: awx-launch-awx-web
      - configMap:
          items:
          - key: nginx_conf
            path: nginx.conf
          name: {{ awx_name }}
        name: awx-nginx-config
      - configMap:
          name: {{ awx_name }}
          items:
          - key: redis_conf
            path: redis.conf
        name: awx-redis-config
      - emptyDir: {}
        name: awx-redis-socket
      - name: awx-secret-key
        secret:
          items:
          - key: secret_key
            path: SECRET_KEY
          secretName: {{ awx_name }}
      - configMap:
          items:
          - key: supervisor-task-config
            path: supervisor_task.conf
          name: {{ awx_name }}
        name: awx-supervisor-task-config
      - configMap:
          items:
          - key: supervisor-web-config
            path: supervisor.conf
          name: {{ awx_name }}
        name: awx-supervisor-web-config
{% if smtps_address | default(False) and k8s_flavor == 'kubernetes' %}
      - name: pkiconf
        projected:
          sources:
          - secret:
              items:
              - key: ca.crt
                path: ca.crt
{% if smtp_tls_provider | default(tls_provider) == 'cert-manager' %}
              name: certmanager-{{ certmanager_ca_name | default(cr_name) }}-root-ca
{% else %}
              name: {{ internal_ca_name | default(cr_name) }}-root-ca
{% endif %}
{% endif %}
{% if do_triggers %}
  triggers:
{% if (opsimages | json_query("[?name=='awx'].short"))[0] %}
  - type: ImageChange
    imageChangeParams:
      automatic: true
      containerNames:
      - web
      from:
        kind: ImageStreamTag
        name: {{ (opsimages | json_query("[?name=='awx'].short"))[0] }}
        namespace: {{ buildns }}
  - type: ImageChange
    imageChangeParams:
      automatic: true
      containerNames:
      - tasks
      from:
        kind: ImageStreamTag
        name: {{ (opsimages | json_query("[?name=='awx'].short"))[0] }}
        namespace: {{ buildns }}
{% endif %}
{% if (opsimages | json_query("[?name=='redis'].short"))[0] %}
  - type: ImageChange
    imageChangeParams:
      automatic: true
      containerNames:
      - redis
      from:
        kind: ImageStreamTag
        name: {{ (opsimages | json_query("[?name=='redis'].short"))[0] }}
        namespace: {{ buildns }}
{% endif %}
  - type: ConfigChange
{% endif %}
